'server.bas
#include "net.bi"

declare sub ServerThread(byval as any ptr)

#define MAX_CLIENTS 100

type CLIENT
  as FDSOCKET hClient
  as any ptr  hThread
  as integer  blnExit
end type   
dim shared as CLIENT  Clients(MAX_CLIENTS-1)
dim shared as integer ClientsConnected

dim as FDSOCKET     hServer
dim as SOCKADDR_IN  Server,Client
dim as integer      ret,addrsize,index,i,blnExit
dim as string       msg
hServer=NetSocket(AF_INET,SOCK_STREAM,0)
if hServer<0 then 
  ? "server: error create socket!"
  beep:sleep:end 1
end if

Server.sin_family=AF_INET
Server.sin_port  =build_port(2310)
Server.sin_addr  =INADDR_ANY
ret=NetBind(hServer,@Server,sizeof(SOCKADDR_IN))
if ret<0 then 
  ? "server: error bind to port!"
  beep:sleep:end 1
end if

ret=NetListen(hServer,3)
if ret<0 then 
  ? "server: error listen!"
  beep:sleep:end 1
end if

? "server: wait on conection shoot down with [CTRL] + [c]"
while blnExit=0
  addrsize=sizeof(SOCKADDR_IN)
  ret=NetAccept(hServer,@Client,@addrsize)
  if ret>-1 then
  ? "server: accept"
    if ClientsConnected<(MAX_CLIENTS-1) then
      ' get next free client
      while Clients(index).hClient<>0
        index+=1
      wend
      Clients(index).hClient=ret
      Clients(index).hThread=ThreadCreate(@ServerThread,cast(any ptr,index))
      ClientsConnected+=1
      ? "server: connections=" & str(ClientsConnected)
    else
      ? "server: full!"
      msg="400 server full!"
      ret=NetSendString(ret,msg)
    end if
  else
    ? "server: error accept!"
    blnExit=1
  end if
wend

if ClientsConnected>0 then
  for i=0 to MAX_CLIENTS-1
    Clients(i).blnExit=1
  next
  sleep 100
end if
  
for i=0 to MAX_CLIENTS-1
  if Clients(i).hThread<>0 then
    ? "server: wait on thread("& str(i) & ")" 
    ThreadWait(Clients(i).hThread)
  end if
  sleep 100
next
? "server: close!"
NetClose hServer
end


sub ServerThread(byval lpany as any ptr)
  dim as integer l,index=cast(integer,lpAny)
  dim as string msg
  ? "thread started for client(" & index & ")"
  Clients(index).blnExit=0
  while Clients(index).blnExit=0
    l=NetReceiveString(Clients(index).hClient,msg)
    if l<1 then
      ? "thread: l<1"
      Clients(index).blnExit=1
    else
      ? "thread:(" & str(index) &") got a message " & msg
      if instr(msg,"exit") then
        msg="exit"
        l=NetSendString(Clients(index).hClient,msg)
        Clients(index).blnExit=1
      else
        ? "thread:(" & str(index) &") send ok"
        msg="ok"
        l=NetSendString(Clients(index).hClient,msg)  
      end if
    end if  
  wend
  ? "thread end for client(" & index & ")"
  NetClose Clients(index).hClient
  Clients(index).hClient=0
  ClientsConnected-=1
end sub
