REM
REM  Few functions related to numeral conversions
REM  This file is part of the zBoy project
REM  Copyright (C) Mateusz Viste 2010
REM


REM Here I am replacing my overkill (and painfully slow) UbyteToByte() function by a simple DEFINE casting
#DEFINE UbyteToByte(ub) cast(byte,(ub))
'FUNCTION UbyteToByte(BYREF UnsignedByte AS UBYTE) AS BYTE
'  REM Returns a signed value from a two-complemented integer
'  'IF UnsignedByte > &b01111111 THEN
'  IF (UnsignedByte AND &b10000000) = 0 THEN ' Value is positive
'      RETURN UnsignedByte
'    ELSE   ' Value is negative
'      RETURN -1 - (UnsignedByte XOR &b11111111)
'  END IF
'END FUNCTION


REM  a #DEFINE is much faster than a FUNCTION
#DEFINE DwordVal(FirstByte, SecondByte) ((SecondByte SHL 8) OR FirstByte)
'FUNCTION DwordVal(BYREF FirstByte AS UBYTE, BYREF SecondByte AS UBYTE) AS UINTEGER
'  REM Get the value of a DWORD (2 bytes -- 16bit unsigned value)
'  RETURN (SecondByte SHL 8) OR FirstByte
'END FUNCTION
