REM
REM  Word-wrapping function
REM  Author: Mateusz Viste
REM  Last modified: 25 Nov 2010
REM
REM Note, that the function will modify the string variable you will pass to it!
REM

FUNCTION WordWrap(BYREF TextToWrap AS STRING, WrapValue AS INTEGER) AS STRING
  DIM AS STRING Result
  DIM AS INTEGER LastSpace = 0, FoundReturn, x
  IF (LEN(TextToWrap) <= WrapValue) AND (INSTR(TextToWrap, CHR(10)) = 0) THEN
      Result = TextToWrap
      TextToWrap = ""
    ELSE
      FoundReturn = 0
      FOR x = 1 TO WrapValue + 1
        IF (TextToWrap[x - 1] = 32) THEN LastSpace = x
        IF (TextToWrap[x - 1] = 10) AND (FoundReturn = 0) THEN FoundReturn = x
      NEXT x
      IF (FoundReturn > 0) THEN LastSpace = FoundReturn
      IF (LastSpace = 0) THEN
          Result = MID(TextToWrap, 1, WrapValue)
          TextToWrap = MID(TextToWrap, WrapValue + 1)
        ELSE
          Result = MID(TextToWrap, 1, LastSpace - 1)
          TextToWrap = MID(TextToWrap, LastSpace + 1)
      END IF
  END IF
  RETURN Result
END FUNCTION
