REM
REM Checks whether the given path is a directory or not.
REM Returns 1 if so, 0 otherwise.
REM
REM Last update: 24 Nov 2010
REM Written by Mateusz Viste
REM

FUNCTION IsDirectory(BYREF ElementToCheck AS STRING) AS BYTE
  DIM AS UINTEGER GetAttribs
  DIM AS STRING TempString, RessourceToCheck = ElementToCheck
  #IFDEF __FB_LINUX__
      DIM AS STRING DirSlash = "/"
    #ELSE
      DIM AS STRING DirSlash = "\"
  #ENDIF
  IF RIGHT(RessourceToCheck, 1) = DirSlash THEN RessourceToCheck = LEFT(RessourceToCheck, LEN(RessourceToCheck) - 1)
  TempString = DIR(RessourceToCheck, &h37, GetAttribs)
  IF (GetAttribs AND &h10) > 0 THEN
      RETURN 1
    ELSE
      RETURN 0
  END IF
END FUNCTION
